<!--
  @description: 报表统计-专家统计-专家地区分布TOP-更多弹框
  @Modifier: 郝定康
  @routerPath:
  @date: 2021-03-03 17:25:37
-->
<template>
  <el-dialog
    v-dialogDrag
    :modal="false"
    :visible.sync="dialog"
    :close-on-click-modal="false"
    title="更多信息"
    width="840px"
  >
    <el-form ref="searchForm" :model="searchForm" inline>
      <el-form-item label="地区">
        <el-input v-model="searchForm.expertArea" />
      </el-form-item>
      <el-form-item class="fr">
        <el-button type="primary" round @click="search">
          查询
        </el-button>
        <el-button type="primary" round @click="resetForm('searchForm')">
          重置
        </el-button>
        <el-button type="primary" round @click="exportChange()">
          导出
        </el-button>
      </el-form-item>
    </el-form>
    <tableChart
      :height="height"
      class="echart-dom"
      :option="option"
    />
    <pagination :pagination-data="paginationData" @change="loadData" />
  </el-dialog>
</template>

<script>
/* api */
import { listExpertArea, exportExpertArea } from '@api/statisticalAnalysis/reportChart.js'
// 地区数据
import { CodeToText } from 'element-china-area-data'
/* 公用方法*/
import { filterObj, restoreInitialValue, download } from '@/assets/js/utils'// 过滤空的key
/* 混合开发方法-参数字段*/
import { ListMixin } from '@/mixins/ListMixin'// 分页
/* 組件 */
import tableChart from './../../components/tableChart'// table列表渲染组件
import pagination from '@comp/common/pagination/pagination'// 分页

export default {
  name: 'ExpertRegionTOPMoreListDialog',
  components: {
    tableChart, // table列表渲染组件
    pagination // 分页
  },
  mixins: [ListMixin],
  data() {
    return {
      height: '450px', // 高度
      dialog: false, // 弹窗状态
      // 查询条件
      searchForm: {
        expertArea: '' // 地区
      },
      // 全局搜索条件
      searchChartData: {

      },
      option: {
        // 非TOP排序
        showIndexTOP: false,
        // 标题
        thead: [
          { lable: '地区', prop: 'expertArea', align: 'left' },
          { lable: '专家人数（个）', prop: 'expertCount', align: 'center' }
        ],
        // 渲染数据
        data: []
      }
    }
  },
  methods: { /**
     * 打开弹窗
     *  @param {row} Object 供应商信息
     *  @param {searchChartData} Object 全局的查询条件
    */
    open(searchChartData) {
      this.dialog = true
      this.searchChartData = searchChartData
      this.paginationData.pageNo = 1
      this.loadData()
    },
    // 获取数据
    loadData() {
      this.option.data = []
      const data = this.getParams()
      listExpertArea(data).then(res => {
        this.paginationData.total = res.data.total
        res.data.records.forEach(item => {
          this.option.data.push({
            ...item,
            expertArea: item.expertArea ? CodeToText[item.expertArea] : ''
          })
        })
        // this.option.data.push(...res.data.records)
        // this.option.data.push(...res.data)
      })
    },
    // 查询条件
    getParams() {
      const param = {
        ...this.searchForm,
        ...this.searchChartData
      }
      param.pageNo = this.paginationData.pageNo
      param.pageSize = this.paginationData.pageSize
      return filterObj(param)// 过滤空的key
    },
    // 搜索
    search() {
      this.paginationData.pageNo = 1
      this.paginationData.pageSize = 10
      this.loadData()
    },
    // 重置
    resetForm(formName) {
      restoreInitialValue(this.searchForm)
      this.search()
    },
    // 导出
    exportChange() {
      const data = this.getParams()
      exportExpertArea(data).then(res => {
        download(res, '专家地区分布信息表.xls')
      })
    },
    // 查看
    detail(row) {
      this.$refs.tenderDetail.open(row.row)
    }
  }
}
</script>

<style scoped lang="less">
</style>
